<?php
namespace nur\sery\schema;

use Exception;

class SchemaException extends Exception {
  static final function invalid_schema(?string $message=null): self {
    $invalid_schema = "invalid schema";
    if ($message !== null) $invalid_schema .= ": $message";
    return new static($invalid_schema);
  }

  static final function invalid_type($value, ?string $message=null): self {
    $invalid_type = var_export($value, true).": invalid type";
    if ($message !== null) $invalid_type .= ": $message";
    return new static($invalid_type);
  }

  static final function invalid_callable($value, ?string $message=null): self {
    $invalid_callable = var_export($value, true).": invalid callable";
    if ($message !== null) $invalid_callable .= ": $message";
    return new static($invalid_callable);
  }
}
