<?php
namespace nur\sery\schema\types;

use nur\sery\schema\values\Result;

/**
 * Interface IType: un type de données
 */
interface IType {
  /**
   * indiquer si la valeur a été fournie par l'utilisateur (elle doit exister
   * et être non vide)
   */
  function available($value, $key=null): bool;

  /**
   * indiquer si la valeur spécifiée existe. cette méthode permet de distinguer
   * les cas "fourni par l'utilisateur mais vide" et "non fourni par l'utilisateur"
   */
  function exists($value, $key=null): bool;

  function verifix(&$value, bool $throw, ?Result &$result);

  function format($value, ?string $format);
}
